# TODO: Add comment
# 
# Author: Judith
###############################################################################

plotEnrichments=function(
		annoTab=NULL,
		clusterTab=NULL,
		projectfolder=getwd(),
		properties=NULL,
		label=NULL,
		plot.setting=Tset,
		plotfolder=NULL,
		xlab='',
		ylab='',
		device='png'){
	require(lattice)
	require(latticeExtra)
	
# check the inputs
# projectfolder
	projectfolder=gsub('/$','',projectfolder)
	cat(createFolderIfNotExist(projectfolder))
	if(is.null(plotfolder)){
		plotfolder=paste(projectfolder,'plots',sep='/')
		cat(createFolderIfNotExist(plotfolder))
	} 
	cat('used folder',plotfolder,'for plotting\n')
	plotfolder=gsub('/$','',plotfolder)
	
# load clusterTab if not supplied	
	clusterTab=loadClusterTab(projectfolder,clusterTabID=clusterTab,FALSE)
	if(class(clusterTab)=='GRanges')
		clusterTab=as.data.frame(elementMetadata(clusterTab))
# clusterTab
	stopifnot(!is.null(clusterTab$clustering),!is.null(clusterTab$silinfo),!is.null(clusterTab$id))
	
	
	annoTab=loadAnnoTab(projectfolder,annoTabID=annoTab,FALSE)
	if(class(annoTab)=='GRanges'){
		cat('convert do dataframe\n')
		ids=names(annoTab)
		annoTab=as.data.frame(elementMetadata(annoTab))
		annoTab$id=ids
	}
	if(is.null(properties)){
		properties=loadLogFile(projectfolder,what='added',colum=2)
	}
# sort both tables according to clustering and silinfo	
	clusterTab=clusterTab[order(clusterTab$clustering,clusterTab$silinfo),]
# prepare for plotting the properties
	properties=properties[properties%in%colnames(annoTab)]
	cat('will plot the following properties',properties,'\n')
	clusterTab=clusterTab[!is.na(clusterTab$clustering),]
	if(class(clusterTab$clustering)!='factor'){
		clusterTab$clustering=factor(clusterTab$clustering)
	}
	clust=clusterTab$clustering
	no_clust=length(unique(clust))# number of clusters -> needed in axis labels
	Type='h';Hori=TRUE
	ft_L=list()
	for(property in properties){
		clusterTab$prop=factor(annoTab[match(clusterTab$id,annoTab$id),property])
		prop=paste(property,':',paste(levels(clusterTab$prop),collapse=', '))
		print(length(clusterTab$prop))
		print(length(clust))
		for(c in unique(clust)){
			ft=fisher.test(clusterTab$prop,clusterTab$clustering==c)
			ft_L[[paste(c,property)]]=c(p.value=ft$p.value,odds=ft$estimate,property=prop,cluster=c)
		}
		cat('calculated',property,'\n')
	}
	plotDF=as.data.frame(do.call(rbind,ft_L))
	plotDF$logOdds=log(as.numeric(as.character(plotDF$odds)))
	plotDF$p.adjust=p.adjust(as.numeric(as.character(plotDF$p.value)))
	plotDF$cluster=factor(plotDF$cluster,levels=levels(clusterTab$clustering))
	bc=barchart(cluster~logOdds|property,data=plotDF,horizontal=TRUE,origin=0,
			groups=p.adjust,
			col='grey',
			panel=function(x,y,groups,subscripts,...){
				panel.barchart(x,y,subscripts=subscripts,...)
				panel.text(x,y,ifelse(x<0&groups[subscripts]<0.05,"*",''),pos=2,cex=2,col='red')
				panel.text(x,y,ifelse(x>0&groups[subscripts]<0.05,"*",''),pos=4,cex=2,col='red')
			})
	if(device=='png'){
		plotfile=paste(plotfolder,'/',label,'enrichment.png',sep='')
		png(plotfile,width=(length(ft_L)*20+50),height=400)
	} else {
		plotfile=paste(plotfolder,'/',label,'enrichment.pdf',sep='')
		pdf(plotfile,width=(length(ft_L)*20+50)/70,height=400/70)
	}
	trellis.par.set(plot.setting)
	plot(update(bc,xlab=xlab,ylab=ylab,
					scales=list(alternating=FALSE),main='',layout=c(length(properties),1)))
	dev.off()
	return(plotfile)
}

