% 
% This is the annotation for the overlapFeaturesAnnotations function
% update it after the function is written

\name{plotHeatMap}
\alias{plotHeatMap}
\title{plotHeatMap}
\description{This function will plot the heatmaps of as many factors as supplied, sorted by the clustering that needs to be supplied as well.}
\usage{
plotHeatMap(clusterTab=NULL,mat,label=NULL,category=NULL, projectfolder=getwd()), xlab = NULL, main = NULL}
\arguments{
	\item{clusterTab}{If supplied, must be of class \code{data.frame} or \code{GRange} and contain at least the following slots: \code{id, clustering, silinfo}. It should be produced with the functions \code{pamClustering}.}
	\item{mat}{Must be of class \code{matrix}. Its rownames must correspond to the id slot of the clusterTab. It is supposed to be the matrix that was used to do the clustering. The \code{colnames(mat)} can contain information about the factors that are clustered and the position. They should be of format \code{number_position}}
	\item{label}{Optional, can be supplied to label the plots.}
	\item{category}{Optional, \code{character}, name of a column in clusterTab. If supplied and present in clusterTab, will be used as additional sorting for the heatmap.}
	\item{xlab}{for heatmap axis annotation.}
	\item{main}{for heatmap axis annotation.}
	\item{projectfolder}{The name of the folder where the project is carried out. Default is the working directory. If no clusterTab is provided, the function will look for the file 'clusterTab.rda' in the project folder and use that instead.}
}

\details{
}

\value{The path to the annoTab in the project folder.}
\author{Judith Zaugg}

\examples{
#source('/Users/zaugg/svn.judith/judith/00_LOG/9999_MYPACKAGES/01_Nucleosomes/AnalyzeGenomicPipeline/R/overlapFeaturesAnnotations.R')
#load('data/htz1GR.rda')
#load('data/tssT.rda')
#overlapFeaturesAnnotations(annoTab=tssT,featureTab=htz1GR,align='start',up=350,down=50,projectfolder='../testACP/',featureNames='htz1')
}
